/*
 * chkdir_14.c
 */
#ifdef DFC
#undef DFC
#endif

#define DFC ((d1)%BMRADIX==1)

#ifndef TUP_MAX
#define TUP_MAX (DEFAULT_NBLK_FILE+1)
#endif


inline
int
comp_fileid(const void *zx, const void *zy)
{
    int x, y;

    x = *((int*)zx);
    y = *((int*)zy);

    return x-y;
}


/*
 *  d1, d2, d3 - directory number
 *  force - flag for force to check outrange directory
 *  dscan - flag for direct scanning
 *  verbose - flag for verbose
 *              0: no verbose, 1: verbose, -1: often
 */
int
skcache_check_dir(int d1, int d2, int d3, int force, int dscan, int verbose)
{
    char basename[L_PATH];
    char dirname[L_PATH];
    char tmp[L_PATH];
    char *namechk;
    dirent_t    *elem;
    DIR         *dirp;
#ifdef PC_NAME_MAX
    dirent_t ent[PC_NAME_MAX+1];
#else
#ifdef _PC_NAME_MAX
    dirent_t ent[_PC_NAME_MAX+1];
#else
    dirent_t ent[128];
#endif
#endif
    char name[L_PATH];
    int dfd;
    char buf[L_BUF];
    int n;
    int i;
    int j, k, r;
    int nr;
    int chk;
    off_t sum;
    off_t fsize;
    int lcount, dcount, ecount;
    off_t lsize, dsize, esize;
    int strange = 0;
    int action;
    int life;
    time_t reftime;
    time_t now;
    int nfile;

    int wid, nwid;

    int lastpos;
    off_t dst, bpos;
    off_t tpos;

    tup rec[TUP_MAX];

    struct timeval begin, end;

    bucket_t *bk;
    skcache_entry_t dummy_en;
    skcache_entry_t dummy_en2;
    skcache_entry_t en;
    skcache_entry_t chunk[HARD_NINDEX_BDREAD];
    int c;
    int er=0;

    int igh=0;
    int nw;

    u_int32_t sig[DSIG_ELEM_WIDTH];
    u_int32_t bit[DBIT_ELEM_WIDTH];

    int sig_pos = 0;

    int dmark_count;

    int ac_sum[ACTION_N];
    int taketime;

    int xx;

#ifdef NP

    char dirpath[L_PATH];
    DIR *dp;
    struct dirent *de;
    int filecount;
    int fileuse[TUP_MAX];
    int fileid[TUP_MAX];

    int file_del;
    void* faddr;

#endif

    gettimeofday(&begin, NULL);
    reftime = begin.tv_sec;
    now = begin.tv_sec;
    dfd = -1;

    xx = rand() % 7607;

    FCHK();

    sig_pos = DSIG_POS(d1, d2, d3);

    dirname[0] = '-';
    dirname[1] = '\0';

    if(verbose<0) {
        if(DFC) {
            verbose = 1;
        }
        else {
            verbose = 0;
        }
    }
    if(dscan<0) {
        dscan = (xx%60);
    }


 if(verbose) {
    Trace("chkdir: start [%d,%d] %s %s : dir# %d, xx %d, (%d %d)\n",
        d1, d2, force ? "force" : "no-force", dscan ? "scan" : "no-scan",
        xx, sig_pos, d1%MAX(radix_disk, 1), reftime);
 }

    lcount  = 0;
    dcount  = 0;
    lsize   = 0;
    dsize   = 0;
    ecount  = 0;
    esize   = 0;

    if(d1<0||d1>=RADIX_H1_MAX
        || d2<0||d2>=RADIX_H2_MAX) {
        Error("chkdir14: ignore directory position %d/%d,%d/%d",
            d1, RADIX_H1_MAX, d2, RADIX_H2_MAX);
        goto out;
    }



    dsig_allclear(sig);
    dbit_allclear(bit);

    bk = &skcache_bucket_base[d1];

#ifdef VD2
#endif
 if(verbose) {
    if(dir_sz[sig_pos]>=dir_size_hwater) {
    }
    Trace("  chkdir14: dir# %d, dir_sz %lld %.2fM %.1f%%, sum %lld %.1f%%, lsize %lld %.1f%%\n",
        sig_pos,
        (long long)dir_sz[sig_pos], fdM(dir_sz[sig_pos]),
            (double)100.0*dir_sz[sig_pos]/dir_size_max,
        (long long)sum, (double)100.0*sum/dir_size_max,
        (long long)lsize, (double)100.0*lsize/dir_size_max);
 }


disk_operations:


#ifdef NP

    for(i=0;i<TUP_MAX;i++) {
        fileuse[i] = -1;
        fileid[i] = -1;
    }

    if(dscan) {
        assign_dir_bynumber2(dirpath, cache_dir_prefix, d1, d2);

		if(verbose) {
			Trace("raw_scandir: target dir %s %d,%d\n", dirpath, d1, d2);
		}

        dp = opendir(dirpath);
        if(dp==NULL) {
            Error("raw_scandir: cannot open dir %s %d,%d",
                dirpath, d1, d2);
            goto scanout;
        }
        
        filecount = 0;
        while(de = readdir(dp)) {
            if(de->d_name[0]=='\0' || de->d_name[0]=='.') {
                continue;
            }
            if(de->d_name[0]=='I') {
                continue;
            }

            fileid[filecount] = atoi(de->d_name);
            fileuse[filecount] = 0;
            if(fileid[filecount]<0) {
                Error(" negative filename '%s' was found", de->d_name);
                continue;
            }

			if(verbose) {
            	Trace("    %4d:f %8d %4d=%04d %s\n",
                	filecount, fileid[filecount],
                	fileid[filecount]/RADIX_H3_MAX,
					fileid[filecount]%RADIX_H3_MAX,
                	de->d_name);
			}

            filecount++;
        }

        closedir(dp);

#if 0
    if(verbose) {
        Trace("  read %d files\n", filecount);
    }
#endif

#if 0
        for(i=0;i<filecount;i++) {
            Trace(" bf %5d %d fileid# %d\n",
                i, fileuse[i], fileid[i],
                fileid[i]/RADIX_H3_MAX, fileid[i]%RADIX_H3_MAX);
        }
#endif

        qsort(fileid, filecount, sizeof(int), comp_fileid);

#if 0
        for(i=0;i<filecount;i++) {
            Trace(" af %5d %d fileid# %d\n",
                i, fileuse[i], fileid[i],
                fileid[i]/RADIX_H3_MAX, fileid[i]%RADIX_H3_MAX);
        }
#endif

scanout:

    if(verbose) {
        Trace("raw_scandir: done %s %d,%d // %d files\n",
            dirpath, d1, d2, filecount);
    }

    }

#endif /* NP */



    n = 0;
    sum = (off_t)0L;

    dummy_en.h1 = d1;
    dummy_en.h2 = d2;
    dummy_en.h3 = 0;
    dummy_en.h4 = 0;

    chk = ifd_open(&dfd, bk, &dummy_en, fszchk);
    if(chk) {
        Error("chkdir14: fail ifd_open() for [%d:%d:%d:%d]",
            dummy_en.h1, dummy_en.h2, dummy_en.h3, dummy_en.h4);
        goto skip_packedfile;
    }
    if(dfd<0) {
        Error("chkdir14: ignore fd# of index file for [%d:%d:%d:%d]",
            dummy_en.h1, dummy_en.h2, dummy_en.h3, dummy_en.h4);
        goto skip_packedfile;
    }

#ifdef XXXTRACE_FD
    Trace("chkdir14: success open dir# %d, fd# %5d \n", sig_pos, dfd);
#endif

    dst = Iseek(sig_pos, dfd, 0);
    if(dst != (off_t)0) {
        Error("chkdir14: frist Iseek: cannot seek to first point, dst %lld",
            (long long)dst);
    }


    /* read all entries in packed file */

    if(nindex_bdread>HARD_NINDEX_BDREAD) {
        nindex_bdread = HARD_NINDEX_BDREAD;
    }

    /* read file, store actions in target table 'rec' */

    for(j=0;j<ACTION_N;j++) {
        ac_sum[j] = 0;
    }

#if 1
        if(ifd_map[sig_pos]<0) {
            Error("read from epmty fd (dir# %d, fd# %d, ita %d) ?",
                sig_pos, dfd, -1);
        }
#endif

    for(j=0;j<Onblk_file;j += nindex_bdread ) {

#if 1
        if(ifd_map[sig_pos]<0) {
            Error("read from epmty fd (dir# %d, fd# %d, ita %d) ?",
                sig_pos, dfd, j);
        }
#endif

/*
        nwid = nindex_bdread;
        wid = nindex_bdread*ESIZE;
*/
        nwid = MIN(nindex_bdread, Onblk_file-j);
        wid = nwid*ESIZE;

        c = 0;
try_read_cntl2:
        c++;
        nr = Iread(sig_pos, dfd, chunk, wid);
        if(nr<0) {
            if(errno==EINTR && c<DISK_RETRY) {
                goto try_read_cntl2;
            }
            Error("chkdir14: file# %d, fpos# %d, fd# %d, fail read() j %d wid %d '%s' %d (%d)",
                n, sig_pos, dfd, j, wid, name, c, errno);
            goto done_read_cntl2;
        }
#if 0
        if(nr<wid)) {
            action = ACTION_PURGE;
            Error("chkdir14: ignore target# %d, pos %d, read control in packed short than control %d/%d",
                n, j, nr, ESIZE);
            goto fill_rest;
        }
#endif

        if(nr==0) {
            break;
        }

        dst += nr;
        nwid = nr/ESIZE;

        for(k=0; k<nwid && j+k < Onblk_file ;k++)
        {
            action = ACTION_NOP;
            en = chunk[k];

            decision_disk_action(&en, reftime, &action);

            if(action<ACTION_N) {
                ac_sum[action]++;
            }

#ifdef VD3
 if(verbose) {
            Trace(" p %4d %4d; => %d; oid# %d, %2x %2x i %9d %5d, l %9d %5d, e %9d %5d \n",
                j+k, n, action,
                en.oid, en.magic[0], en.magic[1],
                en.issue_time, reftime - en.issue_time,
                en.lmd, reftime - en.lmd,
                en.expire, reftime - en.expire
            );

 }
#endif

            if(n>=TUP_MAX) {
                er++;
                if(er==1) {
                    Error(
                        "dir '%s', tup overflow read %d th, store %d th in %d",
                        dirname, i, n, TUP_MAX);
                }
                break;
            }


            if(en.magic[0]==MAGIC_0&&en.magic[1]==MAGIC_1) {
#ifdef PP
                rec[n].no = en.h4; 
#else
/*
                rec[n].no = en.h3 * RADIX_H3_MAX + en.h4; 
*/
                rec[n].no = FNAME(en.h3, en.h4); 
#endif
            }
            else {
                rec[n].no = -753;
            }

/*
Trace("n %d %d <- %s\n", n, rec[n].no, elem->d_name);
*/
            rec[n].type = 1;    /* packed */
            rec[n].pos  = j+k;
            rec[n].act  = action;
            rec[n].date = en.issue_time;
            rec[n].sz   = Oblksize; /* XXX */
            n++;
        }

    }

#if 1
  if(verbose) {
        Trace(" 0 [%d:%d] n %d, Onblk_file %d\n", d1, d2, n, Onblk_file);
  }
    if(n!=Onblk_file) {
    }
#endif


#if 0
    goto done_read_cntl2;
#endif

fill_rest:
 if(verbose) {
    Trace("  dir# %d, fill rest [%d..%d) of packed file\n",
        sig_pos, n, TUP_MAX);
 }

    for(j=n;j<TUP_MAX;j++)
    {
        rec[j].no = -1;
/*
Trace("j %d %d <- %s\n", j, rec[j].no, elem->d_name);
*/
        rec[j].type = 1;    /* packed */
        rec[j].pos  = j;
        rec[j].act  = 2;
        rec[j].date = 0;
        rec[j].sz   = Oblksize; /* XXX */
    }


#if 1
 if(verbose) {
    Trace(" 1 [%d:%d] n %d, Onblk_file %d\n", d1, d2, n, Onblk_file);
 }
#endif




done_read_cntl2:
    (void)1;

#ifdef NP
    if(dscan)
 {
    int x;
    int dx;
    int chk;

 if(verbose) {
    Trace(" comp %d item vs %d files\n", n, filecount);
 }

    for(x=0;x<n;x++) {
        faddr = bsearch(&rec[x].no,
            fileid, filecount, sizeof(int), comp_fileid);
        if(faddr) {
            dx = ((char*)faddr - (char*)fileid)/sizeof(int);
            if(dx>=0 && dx<filecount) {
                fileuse[dx]++;
            }
        }
    }

  if(verbose) {
    for(x=0;x<n;x++) {
        Trace("    %4d:i recno# %9d %4d=%04d\n",
            x, rec[x].no, rec[x].no/RADIX_H3_MAX, rec[x].no%RADIX_H3_MAX);
    }
  }

#if 0
        for(i=0;i<filecount;i++) {
            Trace(" mf %5d %2d fileid# %9d %4d=%04d\n",
                i, fileuse[i], fileid[i],
                fileid[i]/RADIX_H3_MAX, fileid[i]%RADIX_H3_MAX);
        }
#endif

    for(x=0;x<filecount;x++) {
		if(verbose) {
			Trace("     %4d:f %2d fileid# %9d %4d=%04d\n",
				x, fileuse[x], fileid[x],
				fileid[x]/RADIX_H3_MAX, fileid[x]%RADIX_H3_MAX);
		}

        if(fileid[x]>=0 && fileuse[x]==0) {
#if 0
            Trace(" xf %5d %2d fileid# %9d %4d=%04d\n",
                x, fileuse[x], fileid[x],
                fileid[x]/RADIX_H3_MAX, fileid[x]%RADIX_H3_MAX);
#endif
            dummy_en2.h1 = d1;
            dummy_en2.h2 = d2;
            dummy_en2.h3 = fileid[x]/RADIX_H3_MAX;
            dummy_en2.h4 = fileid[x]%RADIX_H3_MAX;

            chk = bfd_delete(&dx, bk, &dummy_en2, 1);
            if(chk<0) {
            }
            else {
                fileuse[x] = -1;
            }
        }
    }

 }
 else {
    Trace(" no raw dir scanning\n");
 }
#endif

    
skip_packedfile:
    (void)1;


    nfile = 1;

#ifdef VD
    if(verbose) {
    Trace("  dir# %d, nfile %d, record %d %d %d, \n",
        sig_pos, nfile, n, Onblk_file, TUP_MAX);
    }
#endif
 if(verbose) {
    int s;
    s = ac_sum[0] + ac_sum[1] + ac_sum[2] + ac_sum[3] + ac_sum[4] + ac_sum[5];
    Trace("  dir# %d, n %d; act known %d, unknown %d ; nop/keep %d, skip/swapout %d, purge %d, swapout+purge %d, mark %d, unlink %d\n",
        sig_pos, n, s, Onblk_file-s,
        ac_sum[0], ac_sum[1], ac_sum[2], ac_sum[3], ac_sum[4], ac_sum[5]);
 }

#if 0
    if(nfile<=0 && has_index==0) {
        goto report_phase;
    }
#endif

#ifdef VD3
    show_tup("after  dir.sweeping", n, rec);
#endif

#ifdef VD3
    if(verbose) {
    Trace("  sweeped file size, sum %lld\n", (long long) sum);
    }
#endif


    /***
     *** main body of compaction
     ***/

#ifdef VD3
 if(verbose) {
    show_tup("before sort1", n, rec);
 }
#endif


    /* 
     * sort by action, date and size
     *     ? black and gray objects will locate to top.
     *      white and gray objects will locate to top.
     *      black and part of gray will be purged.
     *
     */
    qsort(rec, n, sizeof(tup), comp_tup);
#ifdef VD2
 if(verbose) {
    show_tup("after  sort1", n, rec);
 }
#endif

#ifdef VD2
    if(verbose) {
    Trace("  lwater %lld\n", (long long)dir_size_lwater);
    }
#endif

    for(i=0;i<n;i++) {
        int xh1, xh2, xh3, xh4;

#ifdef PP
        xh4 = rec[i].no;
#else
        xh3 = rec[i].no / RADIX_H3_MAX;
        xh4 = rec[i].no % RADIX_H3_MAX;
#endif

#if 0
        Trace("%4d: no# %7d act %2d date %d size %12lld\n",
            i, rec[i].no, rec[i].act, rec[i].date, (long long)rec[i].sz);
#endif

        if(lsize + rec[i].sz > dir_size_lwater) {
#ifdef VD2
    if(verbose) {
            Trace("  change to PURGE from idx %4d pos %4d\n", i, rec[i].pos);
    }
#endif
            break;
        }

        switch(rec[i].act) {
        case ACTION_NOP:
#if 1
        case ACTION_SKIP:
#endif
            /* mark with xh4 */
            DSIG_TMP_SET(sig, xh4);
            DBIT_TMP_SET(bit, rec[i].pos);
            lcount++;
            lsize += rec[i].sz;
            break;

#if 0
        case ACTION_SKIP:
            ecount++;
            esize += rec[i].sz;
            break;
#endif

        case ACTION_PURGE:
        case ACTION_UNLINK:
            dcount++;
            dsize += rec[i].sz;
            break;

        default:
            break;

        }
    }
    for(;i<n;i++) {
        rec[i].act = ACTION_PURGE;
        dcount++;
        dsize += rec[i].sz;
    }

    if(verbose) {
        Trace(
"\tthen, l %9lld d %9lld e %9lld : free %12lld %.2f%%\n",
            (long long)lsize, (long long)dsize, (long long)esize,
            (long long) (dir_size_max - lsize),
            (double)(dir_size_max - lsize)*100.0/dir_size_max
             );
    }
#ifdef VD
#endif

    /*
     * to optimize disk access, sort them with location order
     *
     */
    qsort(rec, n, sizeof(tup), comp_tup_order);

#ifdef VD3
    show_tup("after  sort2", n, rec);
#else
	if(verbose) {
    	show_tup("after  sort2", n, rec);
	}
#endif

    c = 0;
try_lseek_before_writeback:
    c++;
    dst = Iseek(sig_pos, dfd, (off_t)0L);
    if(dst<(off_t)0L) {
        if(errno==EINTR && c<DISK_RETRY) {
            goto try_lseek_before_writeback;
        }
        Error("chkdir14: before write-back, fail lseek() fd# %d, (%d)\n",
            dfd, errno);
    }

    for(i=0;i<n;i++) {
        int xh1, xh2, xh3, xh4;

        if(rec[i].type==1) {
            break;
        }
        if(rec[i].type==0) {
        }

#if 0
        xh4 = rec[i].no;
        sprintf(name, "%s/%d", dirname, xh4);
#endif

#ifdef VD4
    if(verbose) {
Trace("i %d no %d xh4 %d -> %s\n", i, rec[i].no, xh4, name);
    }
#endif

        switch(rec[i].act) {
        case ACTION_PURGE:
            break;

        case ACTION_UNLINK:
            break;
        }
    }

    en.magic[0] = MAGIC_0 & 0xaa;
    en.magic[1] = MAGIC_1 & 0x55;
    en.h1   = -7;
    en.h2   = -17;
    en.h3   = -13;
    en.h4   = -57;
    en.oid  = -83;
    en.issue_time = -1;


#ifdef TRACE_POS2
#endif
#if 0
    for(;i<n;i++) {
        Trace("  del? %4d: pos %4d th slot, action %d\n", i, rec[i].pos, rec[i].act);
    }
#endif
#if 0
    if(verbose) {
        Trace("  del? %4d: pos %4d th slot, action %d\n",
            i, rec[i].pos, rec[i].act);
    }
#endif

#if 1
    if(verbose) {
    Trace("chkdir xx %4d: n %d, TUP_MAX %d\n",
        xx, n, TUP_MAX);
    Trace(" xx %4d: n %d, i %d, TUP_MAX %d\n",
        xx, n, TUP_MAX);
    }
#endif

    dmark_count = 0;
    r = 0;
    
    lastpos = -1;
    tpos = (off_t)0;
    for(;i<n;i++) {
        int xh1, xh2, xh3, xh4;
        int wid, rest, cwid;
        int k;
        struct iovec iov[HARD_NINDEX_BDWRITE];

		if(verbose) {
			Trace("  %4d: action %d\n", i, rec[i].act);
		}
        r++;

#if 0
#ifdef PP
        xh4 = rec[i].no;
#else
        xh3 = rec[i].no / RADIX_H3_MAX;
        xh4 = rec[i].no % RADIX_H3_MAX;
#endif
#endif

        if(rec[i].no>=0 &&
			(rec[i].act==ACTION_PURGE||rec[i].act==ACTION_UNLINK) ) {
            bpos = rec[i].pos*ESIZE;

            dst = Iseek(sig_pos, dfd, bpos);
            if(dst<(off_t)0) {
                Error(
"chkdir14: cannot seek tpos +%lldB, pos %d %lldB on index file fd# %d :%d (%d)",
            (long long)tpos,
            (long)rec[i].pos, (long long)rec[i].pos* ESIZE,
            dfd, c, errno);
                    goto report_phase;
            }


            /* scan delete range */
            j = i;
            while(j<n && rec[j].act == rec[i].act) {
                j++;
            }

            nindex_bdwrite = 32;

#if 0
            wid = rest = j-i-1;
#endif
            wid = rest = j-i; 	/* XXX */

            while(rest>0) {
                cwid = MIN(rest, nindex_bdwrite);
#if 0
Trace("     wid %4d, rest %4d, cwid %4d\n", wid, rest, cwid);
#endif

                for(k=0;k<cwid;k++) {
                    iov[k].iov_base = &en;
                    iov[k].iov_len  = ESIZE;
                }

#if 1
	if(verbose) 
	{
		int k;

#if 0
		Trace("    xx %d\n", xx);
#endif
		for(k=i;k<i+cwid;k++) {
			Trace("          %4d: write deleted mark to recno# %9d\n",
				k, rec[k].no);
		}
	}
#endif

                nw = Iwritev(sig_pos, dfd, iov, cwid);
                if(nw<0) {
                    Error("chkdir14: fail deletation marking dfd# %d, (%d)",
                        dfd, errno);
                    goto skip_deleting;
                }
                rest-= cwid;
                dst += nw;
                dmark_count += cwid;
            }
              

            /* when PP mode, body file modification is not required.
             * 
             */
#ifdef NP
        {
            int bchk;
            int jfd;
            int bi;
            int lastno;


#if 0
            lastno = -1783;
            if(verbose) {
                Trace("  chunk i %d, j %d (xx %d)\n", i, j, xx);
            }
            for(bi = i;bi<j;bi++) {
                if( rec[bi].no != lastno) {
                    if(verbose) {
                    Trace("  %4d: recno# %9d %4d=%04d\n",
                        bi, rec[bi].no,
                        rec[bi].no / RADIX_H3_MAX, rec[bi].no % RADIX_H3_MAX);
                    }
                }
                lastno = rec[bi].no;
            }
#endif

#if 1
            if(verbose) {
                Trace("       purged range [%d,%d), num %d\n", i, j, j-i);
            }
#endif

            lastno = -1;
            bi = i;
            while(bi<j) {

                /* delete object using first block */
                xh3 = rec[bi].no / RADIX_H3_MAX;
                xh4 = rec[bi].no % RADIX_H3_MAX;


                if(dscan) {
                    faddr = bsearch(&rec[bi].no,
                        fileid, filecount, sizeof(int), comp_fileid);
                }
                else {
                    faddr = (void*)0xffff;
                }

#if 1
                if(verbose) {
                Trace("        %4d: recno# %9d %4d=%04d, faddr %x\n",
                    bi, rec[bi].no, xh3, xh4, faddr);
                }
#endif

                if(xh3>=0 && xh4>=0 && faddr) {
                    dummy_en2.h1 = d1;
                    dummy_en2.h2 = d2;
                    dummy_en2.h3 = xh3;
                    dummy_en2.h4 = xh4;
            
#if 1
                    if(verbose) {
                        Trace(
				"            call bfd_delete %d,%d,%d,%d (xx %d)\n",
                            d1, d2, xh3, xh4, xx);
                    }
#endif
                    bchk = bfd_delete(&jfd, bk, &dummy_en2, 1);
                }
#if 0
                else {
                    if(verbose) {
                        Trace(
				"            no-call bfd_delete %d,%d,%d,%d (xx %d)\n",
                            d1, d2, xh3, xh4, xx);
                    }
                }
#endif


                /* skip blocks until next object */
                lastno = rec[bi].no;
                bi++;
                while(bi<j && rec[bi].no==lastno) {
                    bi++;
                }
#if 0
                Trace("  next to %d\n", bi);
#endif

            }
        }
#endif


            if(r>n) {
                Trace("  escape %d/%d, bk# %d,\n", r, n, sig_pos);
                break;
            }

            if(i+wid+1 >= n) {
#if 0
                Trace("  reach to end\n");
#endif
                break;
            }
            else {
                i += wid;
				--i; /* erase natural increment of 'for'-loop */
            }

        }
        else {
        }

    }

skip_deleting:
    (void)0;

#ifdef VD
    Trace("  write deletation mark %d\n", dmark_count);
#endif

#if 1
    if(dst>(off_t) Onblk_file*ESIZE) { 
        Error("INDEX [%03d:%03d] overrun %lldB (%ld slots) ; expect %lldB (%ldB entry x %ld slots)",
            d1, d2,
            (long long) dst, (long)((long long)dst/ESIZE),
            (long long) Onblk_file*ESIZE,
            (long) ESIZE, (long) Onblk_file);
    }
#endif


report_phase:

    now = time(NULL);

#ifdef VD
#endif
 	if(verbose) {
    	Trace(" dd dir# %d, %-24s %4d sum %8ld + %d\
/ live %4d %8ld / dead %4d %8ld\
/ untouch %4d %8ld / %2d\n",
			sig_pos, dirname, n, (long)sum, strange,
			lcount, (long)lsize, dcount, (long)dsize, ecount, (long)esize,
			now - reftime
        	);
  	}

  if(force) {

    MUTEX_LOCK(&stat_lock);

    checkdir_dir_count++;
    checkdir_file_read_count    += nfile;
    checkdir_file_handle_count  += n;
    checkdir_file_left_count    += lcount;
    checkdir_file_delete_count  += dcount;
    checkdir_file_erase_count   += ecount;

    check_dir_ignore_hash_count = igh;

    if(dcount>0 && dsize>0) {
        swap_count  -= dcount;
        swap_size   -= dsize;
    }

    MUTEX_UNLOCK(&stat_lock);

#if 0 
    MUTEX_LOCK(&dir_mutex);
#endif

    memcpy((void*)&dir_sig[sig_pos*DSIG_ELEM_WIDTH],
        (void*)&sig, DSIG_ELEM_WIDTH*sizeof(u_int32_t));
    memcpy((void*)&dir_bit[sig_pos*DBIT_ELEM_WIDTH],
        (void*)&bit, DBIT_ELEM_WIDTH*sizeof(u_int32_t));

    dir_sz[sig_pos]     = lsize;
    dir_count[sig_pos]  = lcount;
    dir_time[sig_pos]   = now;
    dir_lack[sig_pos]   = 0;

#if 0
    MUTEX_UNLOCK(&dir_mutex);
#endif
  }


out:

#if 1
    if(dfd>=0) {
#ifdef XXXTRACE_FD
        Trace("chkdir14: try close dir# %d, fd# %5d \n", sig_pos, dfd);
#endif
        chk = ifd_close(&dfd, bk, &dummy_en);
        if(chk) {
            Error("chkdir14: fail ifd_close() for [%d:%d:%d:%d]",
                dummy_en.h1, dummy_en.h2, dummy_en.h3, dummy_en.h4);
        }
    }
#endif

    gettimeofday(&end, NULL);
    taketime = KOTETU_SUB_TIME(end, begin);
    sim_stat_add_value(&checkdir_time, taketime);
    sim_stat_add_value(&checkdir_time_short, taketime);

#ifdef TRACE_CHKDIR
#endif

 	if(verbose) {
		Trace(
"chkdir: done dir# %d, takes %d msec, %-17s left %4df %8ldB %7.2fKB  th %08x\n",
        sig_pos, taketime, dirname,
        lcount, (long)lsize, fdK(lsize), pthread_self());
 	}

#if 0
    Trace("chkdir: done dir# %d, takes %d sec, %-17s left %4df %8ldB %7.2fKB  th %08x\n",
        sig_pos, taketime, dirname,
        lcount, (long)lsize, fdK(lsize), pthread_self());
#endif

end:
    FCHK();

    return 0;
}


/*** end of chkdir_14.c ***/
